commit de32296674ed4e57cb5a8efa3bb3f2c838d03d1a
Author: Jeremy Harris <jgh146exb@wizmail.org>
Date:   Sun Nov 30 10:19:10 2025 +0000

    add version checking and grooming for hintsdb records

diff --git a/src/src/dbfn.c b/src/src/dbfn.c
index 0a05524e1..64807a7b8 100644
--- a/src/src/dbfn.c
+++ b/src/src/dbfn.c
@@ -17,25 +17,29 @@ with database files like $spooldirectory/db/<name> */
 
 
 /* Functions for accessing Exim's hints database, which consists of a number of
-different DBM files. This module does not contain code for reading DBM files
-for (e.g.) alias expansion. That is all contained within the general search
-functions. As Exim now has support for several DBM interfaces, all the relevant
+different DBM files.  Also used for the readonly access for dbm lookup
+expansions via the general search functions, for non-hints DBM file.
+
+As Exim now has support for several DBM interfaces, all the relevant
 functions are called as inlinable functions from an included file.
 
-All the data in Exim's database is in the nature of *hints*. Therefore it
+All the data in Exim's hists database is in the nature of *hints*. Therefore it
 doesn't matter if it gets destroyed by accident. These functions are not
 supposed to implement a "safe" database.
 
-Keys are passed in as C strings, and the terminating zero *is* used when
-building the dbm files. This just makes life easier when scanning the files
+For hints, keys are passed in as C strings - and the terminating zero *is* used
+when building the dbm files. This just makes life easier when scanning the files
 sequentially.
 
-Synchronization is required on the database files, and this is achieved by
-means of locking on independent lock files. (Earlier attempts to lock on the
-DBM files themselves were never completely successful.) Since callers may in
-general want to do more than one read or write while holding the lock, there
-are separate open and close functions. However, the calling modules should
-arrange to hold the locks for the bare minimum of time.
+For many of the DBM interfaces, synchronization is required on the database
+files; and this is achieved by means of locking on independent lock files.
+(Earlier attempts to lock on the DBM files themselves were never completely
+successful.) Since callers may in general want to do more than one read or write
+while holding the lock, there are separate open and close functions.
+However, the calling modules should arrange to hold the locks for the bare
+minimum of time.
+A predicate call is provided to tell if this locking is required, as opposed
+to being built-in to the DBM.
 
 API:
   exim_lockfile_needed			facilities predicate
@@ -62,6 +66,13 @@ Users:
   peer capability cache
   callout & quota cache
   DBM lookup type
+
+
+NOTE: the autoreply transport accesses a DBM database using
+exim_db{open,close,get,put} directly, not using this layer.
+
+The DBM interface is selected at build time from one of the
+files src/hintsdb/hints_*.h
 */
 
 
@@ -430,12 +441,30 @@ if (!exim_dbget(dbblock->dbptr, &key_datum, &result_datum))
 dlen = exim_datum_size_get(&result_datum);
 DEBUG(D_hints_lookup) debug_printf_indent("dbfn_read: size %u return\n", dlen);
 
-/* Hintsdb uses store the taint of the payload of the value in the value.
-For non-hints uses we have no provenance, so assume untainted */
+if (hintsdb)
+  {
+  dbdata_generic *  gp = (dbdata_generic *) exim_datum_data_get(&result_datum);
 
-tainted = hintsdb
-  ? ((dbdata_generic *) exim_datum_data_get(&result_datum))->tainted
-  : FALSE;
+  if (dlen < sizeof(dbdata_generic))
+    {
+    DEBUG(D_hints_lookup)
+      debug_printf_indent("dbfn_read: bad record size %u\n", dlen);
+    return NULL;
+    }
+  if (gp->version != HINTS_VERSION)
+    {
+    DEBUG(D_hints_lookup)
+      debug_printf_indent("dbfn_read: bad record version %u\n", gp->version);
+    return NULL;
+    }
+
+  /* Hintsdb uses store the taint of the payload of the value in the value.
+  For non-hints uses we have no provenance, so assume untainted */
+
+  tainted = gp->tainted;
+  }
+else
+  tainted = FALSE;
 
 yield = store_get(dlen+1, tainted ? GET_TAINTED : GET_UNTAINTED);
 memcpy(yield, exim_datum_data_get(&result_datum), dlen);
@@ -519,13 +548,14 @@ int
 dbfn_write(open_db * dbblock, const uschar * key, void * ptr, int length)
 {
 EXIM_DATUM key_datum, value_datum;
-dbdata_generic *gptr = (dbdata_generic *)ptr;
+dbdata_generic * gptr = (dbdata_generic *)ptr;
 int klen = Ustrlen(key) + 1;
 uschar * key_copy = store_get(klen, key);
 
 memcpy(key_copy, key, klen);
-gptr->time_stamp = time(NULL);
+gptr->version = HINTS_VERSION;
 gptr->tainted = is_tainted(ptr);
+gptr->time_stamp = time(NULL);
 
 DEBUG(D_hints_lookup)
   debug_printf_indent("dbfn_write: key=%s datalen %d\n", key, length);
diff --git a/src/src/exim_dbutil.c b/src/src/exim_dbutil.c
index 2c03be1c5..f3842874f 100644
--- a/src/src/exim_dbutil.c
+++ b/src/src/exim_dbutil.c
@@ -380,7 +380,8 @@ if (exim_lockfile_needed())
   exclusive access to the database, so we can go ahead and open it. */
   }
 
-if (asprintf(CSS &filename, "%s", name) < 0) return NULL;
+/* Drop the ".lockfile" off the name */
+*Ustrrchr(filename, '.') = '\0';
 
 if (!(dbblock->dbptr = dbblock->readonly && !exim_lockfile_needed()
 		      ? exim_dbopen_multi(filename, dname, flags, 0)
@@ -447,7 +448,7 @@ Arguments:
   length    where to put the length (or NULL if length not wanted). Includes overhead.
 
 Returns: a pointer to the retrieved record, or
-         NULL if the record is not found
+         NULL if the record is not found or bad
 */
 
 void *
@@ -467,26 +468,42 @@ exim_datum_init(&result_datum);      /* to be cleared before use. */
 exim_datum_data_set(&key_datum, key_copy);
 exim_datum_size_set(&key_datum, klen);
 
-if (!exim_dbget(dbblock->dbptr, &key_datum, &result_datum)) return NULL;
-
-/* Assume for now that anything stored could have been tainted. Properly
-we should store the taint status along with the data. */
+if (!exim_dbget(dbblock->dbptr, &key_datum, &result_datum))
+  return NULL;
 
 dlen = exim_datum_size_get(&result_datum);
+DEBUG(D_hints_lookup) debug_printf_indent("dbfn_read: size %u return\n", dlen);
+if (length) *length = dlen;
 
 /* Hintsdb uses store the taint of the payload of the value in the value.
 For non-hints uses we have no provenance, so assume untainted */
 
-tainted = dbmdb
-  ? FALSE
-  : ((dbdata_generic *) exim_datum_data_get(&result_datum))->tainted;
+if (dbmdb)
+  tainted = FALSE;
+else
+  {
+  dbdata_generic * gp = (dbdata_generic *) exim_datum_data_get(&result_datum);
+  if (dlen < sizeof(dbdata_generic))
+    {
+    DEBUG(D_hints_lookup)
+      debug_printf_indent("dbfn_read: bad record size %u\n", dlen);
+    return NULL;
+    }
+  if (gp->version != HINTS_VERSION)
+    {
+    DEBUG(D_hints_lookup)
+      debug_printf_indent("dbfn_read: bad record version %u; deleting\n",
+			    gp->version);
+    return NULL;
+    }
+
+  tainted = gp->tainted;
+  }
 
 yield = store_get(dlen, tainted ? GET_TAINTED : GET_UNTAINTED);
 memcpy(yield, exim_datum_data_get(&result_datum), dlen);
-DEBUG(D_hints_lookup) debug_printf_indent("dbfn_read: size %u return\n", dlen);
-if (length) *length = dlen;
+exim_datum_free(&result_datum);		/* Some DBM libs require freeing */
 
-exim_datum_free(&result_datum);    /* Some DBM libs require freeing */
 return yield;
 }
 
@@ -726,13 +743,10 @@ for (uschar * key = dbfn_scan(dbm, TRUE, &cursor);
 	  printf("%s ", name);
 	  t += MESSAGE_ID_LENGTH;
 	  }
-	printf("\n");
+	putchar('\n');
 	break;
 
       case type_misc:
-	/* It might be nice to recognize the subtypes of "misc" DBs (by the
-	key prefix?) for better decode.  For now, dump the raw data. */
-
 	{
 	dbdata_generic * recp = (dbdata_generic *)value;
 	uschar * dp = US (recp + 1);
@@ -1368,16 +1382,26 @@ the store each time round. */
 
 for (; keychain && (reset_point = store_mark()); store_reset(reset_point))
   {
-  dbdata_generic *value;
+  dbdata_generic * value;
+  int size = 0;
 
   key = keychain->key;
   keychain = keychain->next;
-  value = dbfn_read_with_length(dbm, key, NULL);
+  value = dbfn_read_with_length(dbm, key, &size);
 
   /* A continuation record may have been deleted or renamed already, so
-  non-existence is not serious. */
+  non-existence is not serious. Also, for a back-version record we get
+  a null value - so attempt a delete. */
 
-  if (!value) continue;
+  if (!value)
+    {
+    if (size)
+      {
+      printf(" deleted %s (bad record version)\n", key);
+      dbfn_delete(dbm, key);
+      }
+    continue;
+    }
 
   /* Delete if too old */
 
diff --git a/src/src/hintsdb_structs.h b/src/src/hintsdb_structs.h
index f4d72fdc9..fdca1f468 100644
--- a/src/src/hintsdb_structs.h
+++ b/src/src/hintsdb_structs.h
@@ -25,17 +25,20 @@ typedef struct {
 } open_db;
 
 
-/* Structures for records stored in exim database hinsts files. They all
+/* Structures for records stored in exim database hints files. They all
 start with the same fields, described in the generic type.
 DBM databases are used for hints files.
 */
 
 
 typedef struct {
-  time_t time_stamp;	/* Timestamp of writing */
+  unsigned version;
   BOOL	 tainted;	/* metadata for the "value" part of the record */
+  time_t time_stamp;	/* Timestamp of writing */
 } dbdata_generic;
 
+#define	HINTS_VERSION	2
+
 
 /* This structure keeps track of retry information for a host or a local
 address. */

